/*
***********************************
GameCube Pong, By DesktopMan
(DesktopMan[at]fritidsproblemer.no)
Last updated: 21.06.03 16:28 gmt+1
**********************************

Thanks to:	Costis, for inspiration, etc etc
			Peter from console-dev.de, for Pad source
			Titanik for init and example code
			#gcdev for not beeing lame ALL the time
			Torlus for gcc build
			Probably someone else, you know who you are

First source release, use at your own risc. More features coming soon.
Use of any parts of this source, except in whole, is hereby granted.
A thank you would be nice though :)
www.gcdev.com

This file will be updated regulary, so just download it once in a while :)

ps:

Since how much you can see is different from each tv, experiment with x's and y's.

ps2:

Add these to your video.h
*/
#define COLOR_WHITE			0xFF80FF80
#define COLOR_BLUE			0x1DFF1D6B
#define COLOR_RED			0x4C554CFF
#define COLOR_BLACK                     0x10801080
 
 
// Change these to where you keep your libs

#include "types.h"
#include "video.h"
#include "pad.h"
#include ".\gfx\font.h"

// Hot-reset, mapped to Start. Very handy. Thanks to http://duke.napalm-x.com/ and Peter for this one
#define REG_HOTRESET             (0xCC003024)
#define REG_HOTRESET_PTR         ((volatile u32*)REG_HOTRESET)
#define M_HOTRESET               *REG_HOTRESET_PTR = 0x00000000;

// Framebuffer
u32* fb = (u32*)0xC0500000;

PAD pad[2];

// Paddle structs
struct sprite{
	int x;
	int y;
	int points; // Counted for, but not shown on screen yet. wip
}player[2];

// Ball struct
struct bsprite{
	int x;
	int y;
	int xspeed;
	int yspeed;
}ball;

// Function declarations
void GetInput();
void ClearScreen(int color);
void BlitScreen();
void MoveBall();
int HitDet();
void PrintNumber(int x,int y,int number);


void PadInit()
{
    int i;
    *(volatile unsigned long*) 0xCC002000 = 0x0F060001;
    *(volatile unsigned long*) 0xCC006400 = 0x00400300; 
    *(volatile unsigned long*) 0xCC00640C = 0x00400300;
    *(volatile unsigned long*) 0xCC006418 = 0x00400300;
    *(volatile unsigned long*) 0xCC006424 = 0x00400300;        
    *(volatile unsigned long*) 0xCC006430 = 0x000701f0; 
    *(volatile unsigned long*) 0xCC006438 = 0x80000000; 
    while (!((*(volatile unsigned long*) 0xCC006438)&0x20000000));
}

int main()
{
    PadInit();
    // Init video in PAL mode, change this to your video-mode.
    VIDEO_Init (VIDEO_640X480_PAL60_YUV16);

//    vidSetFrameBuffer ((u32)fb);
    VIDEO_SetFrameBuffer (VIDEO_FRAMEBUFFER_BOTH,(u32)fb);


	// Init ball and players' pos.
	player[0].x=30;
	player[0].y=200;
	player[0].points=0;

	player[1].x=290;
	player[1].y=200;
	player[1].points=0;
		
	ball.x=100;
	ball.y=100;
	ball.xspeed=2;
	ball.yspeed=4;

    while(1) // Main game loop
    {   
//		vidWaitRetrace(); // Wait for vblank
		VIDEO_WaitVSync();

		PAD_ReadState(&pad[0], PAD_CHANNEL_0); // Read pads
		PAD_ReadState(&pad[1], PAD_CHANNEL_1);

		ClearScreen(COLOR_BLACK); // Paint the screen black
	
		BlitScreen(); // Draw paddles and ball
		MoveBall(); // duh
		GetInput(); // duh
		
		if(pad[0].Digital.Start) // Hot-reset if start is pressed
			M_HOTRESET;		
	}    
    return 0;
}

void GetInput(){ // Controller input
	if(pad[0].Analog.Y>20&&player[0].y<400)
		player[0].y+=5;

	if(pad[1].Analog.Y>20&&player[1].y<400)
		player[1].y+=5;

	if(pad[0].Analog.Y<-20&&player[0].y>20)
		player[0].y-=5;

	if(pad[1].Analog.Y<-20&&player[1].y>20)
		player[1].y-=5;
}

void ClearScreen(int color){ // Clear the screen in a certain color
	int x,y;

	for(y=0;y<480;y++){
		for(x=0;x<320;x++){
			fb[x+320*y]=color;
		}
	}
}

void BlitScreen(){ // Draw everything
	int x,y;
	for(y=player[0].y;y<player[0].y+64;y++){
		for(x=player[0].x;x<player[0].x+8;x++)
			fb[x+320*y]=COLOR_RED;
	}

	for(y=player[1].y;y<player[1].y+64;y++){
		for(x=player[1].x;x<player[1].x+8;x++)
			fb[x+320*y]=COLOR_RED;
	}

	for(y=ball.y;y<ball.y+8;y++){
		for(x=ball.x;x<ball.x+4;x++)
			fb[x+320*y]=COLOR_BLUE;
	}
	PrintNumber(20,30,player[0].points);
	PrintNumber(290,30,player[1].points);
}

void MoveBall(){
	if(ball.y<=20)
		ball.yspeed=4;
	if(ball.y>=440)
		ball.yspeed=-4;
	if(ball.x<=20){
		ball.xspeed=2;
		player[1].points++;
	}
	if(ball.x>=312){
		ball.xspeed=-2;
		player[0].points++;
	}

	if(HitDet(player[0].x,player[0].y,16,64,ball.x,ball.y,8,8))
		ball.xspeed=2;

	if(HitDet(player[1].x,player[1].y,16,64,ball.x,ball.y,8,8))
		ball.xspeed=-2;

	ball.x+=ball.xspeed;
	ball.y+=ball.yspeed;
}

int HitDet(int x1, int y1, int w1, int h1,int x2, int y2, int w2, int h2){ // Hit detection between two objects
	if(x1+w1>x2&&x1<x2+w2&&y1+h1>y2&&y1<y2+h2)
		return 1;
	return 0;
}

void PrintNumber(int x,int y,int number){ // No, scores over 100 is not supported, you sick pong addict :P
	int X,Y;
	u32 *font=(u32*)image;
	if(number<10){
		for(Y=y;Y<y+24;Y++){
			for(X=x;X<x+12;X++){
				fb[X+320*Y]=font[X-x+(Y-y)*12+number*24*12];
			}
		}
	}
	else{
		int num1,num2;
		num1=number/10;
		num2=number-num1*10;

		for(Y=y;Y<y+24;Y++){
			for(X=x;X<x+12;X++){
				fb[X+320*Y]=font[X-x+(Y-y)*12+num1*24*12];
			}
		}

		for(Y=y;Y<y+24;Y++){
			for(X=x;X<x+12;X++){
				fb[X+13+320*Y]=font[X-x+(Y-y)*12+num2*24*12];
			}
		}

	}
}
